﻿#include "DIALOG.h"

/*********************************************************************
*
*       Externals
*
**********************************************************************
*/

/*********************************************************************
*
*       Types
*
**********************************************************************
*/

/*********************************************************************
*
*       Defines
*
**********************************************************************
*/

/*********************************************************************
*
*       Static data
*
**********************************************************************
*/

/*********************************************************************
*
*       Static code
*
**********************************************************************
*/
/*********************************************************************
*
*       _cbWin0
*/
static void _cbWin0(WM_MESSAGE * pMsg) {
  GUI_RECT Rect;

  switch (pMsg->MsgId) {
  case WM_PAINT:
    GUI_SetBkColor(GUI_LIGHTYELLOW);
    GUI_Clear();
    WM_GetClientRect(&Rect);
    GUI_SetColor(GUI_BLACK);
    GUI_DispStringInRect("Window 0", &Rect, GUI_TA_HCENTER | GUI_TA_VCENTER);
    break;
  default:
    WM_DefaultProc(pMsg);
    break;
  }
}

/*********************************************************************
*
*       _cbWin1
*/
static void _cbWin1(WM_MESSAGE * pMsg) {
  GUI_RECT Rect;

  switch (pMsg->MsgId) {
  case WM_PAINT:
    GUI_SetBkColor(GUI_LIGHTBLUE);
    GUI_Clear();
    WM_GetClientRect(&Rect);
    GUI_SetColor(GUI_BLACK);
    GUI_DispStringInRect("Window 1", &Rect, GUI_TA_HCENTER | GUI_TA_VCENTER);
    break;
  default:
    WM_DefaultProc(pMsg);
    break;
  }
}

/*********************************************************************
*
*       _cbWin2
*/
static void _cbWin2(WM_MESSAGE * pMsg) {
  GUI_RECT Rect;

  switch (pMsg->MsgId) {
  case WM_PAINT:
    GUI_SetBkColor(GUI_LIGHTGREEN);
    GUI_Clear();
    WM_GetClientRect(&Rect);
    GUI_SetColor(GUI_BLACK);
    GUI_DispStringInRect("Window 2", &Rect, GUI_TA_HCENTER | GUI_TA_VCENTER);
    break;
  default:
    WM_DefaultProc(pMsg);
    break;
  }
}

/*********************************************************************
*
*       _cbWin3
*/
static void _cbWin3(WM_MESSAGE * pMsg) {
  GUI_RECT Rect;

  switch (pMsg->MsgId) {
  case WM_PAINT:
    GUI_SetBkColor(GUI_LIGHTRED);
    GUI_Clear();
    WM_GetClientRect(&Rect);
    GUI_SetColor(GUI_BLACK);
    GUI_DispStringInRect("Window 3", &Rect, GUI_TA_HCENTER | GUI_TA_VCENTER);
    break;
  default:
    WM_DefaultProc(pMsg);
    break;
  }
}

/*********************************************************************
*
*       _cbBk
*/
static void _cbBk(WM_MESSAGE * pMsg) {
  switch (pMsg->MsgId) {
  case WM_PAINT:
    GUI_SetBkColor(GUI_BLACK);
    GUI_Clear();
    break;
  default:
    WM_DefaultProc(pMsg);
    break;
  }
}


/*********************************************************************
*
*       _ButtonState
*/
static int _ButtonState(void) {
  //
  // A dummy function, needs to be adapted on your own
  //
  GUI_Delay(1000);  // I perform a delay just to slow doen the window changes
  return 1;
}


/*********************************************************************
*
*       Public code
*
**********************************************************************
*/
/*********************************************************************
*
*       MainTask
*/
void MainTask(void) {
  WM_CALLBACK * aCb[] = {  // Array of callback functions, this way we can create the window within a loop
    _cbWin0,
    _cbWin1,
    _cbWin2,
    _cbWin3
  };
  WM_HWIN ahWin[4];        // Array of window handles
  int     Index;

  //
  // Initialize emWin
  //
  GUI_Init();
  //
  // Use multibuffering if possible
  //
  WM_MULTIBUF_Enable(1);
  //
  // Set a callback for the desktop window, not required but this way we are on the save side
  //
  WM_SetCallback(WM_HBKWIN, _cbBk);
  //
  // Create four windows, hidden
  //
  for (Index = 0; Index < (int)GUI_COUNTOF(ahWin); Index++) {
    ahWin[Index] = WM_CreateWindowAsChild(0, 0, LCD_GetXSize(), LCD_GetYSize(), WM_HBKWIN, WM_CF_HIDE, aCb[Index], 0);
  }
  //
  // Initially show the first window
  //
  Index = 0;
  WM_ShowWindow(ahWin[Index]);
  while (1) {
    //
    // Perform a short delay, GUI_Delay() also takes care about updating the windows
    //
    GUI_Delay(5);
    //
    // Poll button state, this is just a dummy function and needs to be replaced by your own
    //
    if (_ButtonState()) {
      //
      // If the button is pressed hide the current window
      //
      WM_HideWindow(ahWin[Index]);
      //
      // Modify Index
      //
      Index = (Index < (int)GUI_COUNTOF(ahWin) - 1) ? Index + 1 : 0;
      //
      // Show the next window
      //
      WM_ShowWindow(ahWin[Index]);
    }
  }
}

/*************************** End of file ****************************/
